TITLE StartCombo.asm

;                           ====================
;============================  DialogKeep.asm  ================================
;==                         ====================                             ==
;==                                                                          ==
;== Project         : ScanGui                                                ==
;== Filename        : StartCombo.asm                                         ==
;== Version         : 1                                                      ==
;== Date            : Jul 15, 2008                                           ==
;== Compiler        : Masm v. 6.14 by Microsoft Corporation.                 ==
;== Purpose         : Housekeeping of main dialog.                           ==
;==                                                                          ==
;==============================================================================
;==                                                                          ==
;== Copyright (c) 2008, P. H. Duarte                                         ==
;== All rights reserved.                                                     ==
;==                                                                          ==
;==============================================================================

; VERSION HISTORY:
; ----------------

; Version           : 1
; Date              : Jul 15, 2008
; Revised by        : P. H. Duarte
; Description       : Original Version.
;==============================================================================
; Version			: 1.01
; Date				: Nov 05, 2008
; Description		 * Added check error on combo box initialization.
;==============================================================================

.686
.model flat, stdcall
option casemap:none

;==============================================================================
;==                         Include Files                                    ==
;==============================================================================

include ScangII.inc
include inc\ids.inc

;==============================================================================
;==                          Local Data                                      ==
;==============================================================================

.data
; ---> Compilers table and options.  <---
szFasm			CHAR	"Fasm", 0
szFasm2			CHAR	"Fasm =2", 0
szFasmGO		CHAR	"Fasm + Golink", 0
szFasmAl		CHAR	"Fasm + Alink", 0
szFasmMSD		CHAR	"Fasm + Polink(direct)", 0
szFasmMSI		CHAR	"Fasm + Polink(indirect)", 0
szGOasm			CHAR	"Goasm", 0
szGOasm2		CHAR	"Goasm  =2", 0
szMasm			CHAR	"Masm   =1", 0						
szMasm2			CHAR	"Masm   =2", 0
szMasm3			CHAR	"Masm   =3", 0
szMasm4			CHAR	"Masm   =4", 0
szMasm5			CHAR	"Masm   =5", 0
szMasm6			CHAR	"Masm   =6", 0
szMasm7 		CHAR	"Masm   =7", 0
szTasm			CHAR	"Tasm/LzAsm", 0
szLzAsm			CHAR	"LzAsm =2", 0
szLzAsm3		CHAR 	"LzAsm =3", 0 
szNasm			CHAR	"NASM", 0
szHLA			CHAR	"HLA", 0
szLibMod		CHAR	"Library Modules", 0

dwTypeTable		DWORD	szFasm, szFasm2, szFasmGO, szFasmAl, szFasmMSD, 
						szFasmMSI, szGOasm, szGOasm2, szMasm, szMasm2, szMasm3,
						szMasm4, szMasm5, szMasm6, szMasm7, szTasm, szLzAsm,
						szLzAsm3, szNasm, szHLA, szLibMod

szComboBoxError	CHAR	"Combo box error.Close the program.", 0

; ---> Table of string buffers to be cleaned.

dwCleanTable	DWORD	lpstrFile, szFilePath, szScanCmdLine, szOutName


;==============================================================================			

.code	

;==============================================================================
;
; Function StartCombo (hwnd)
;
; Purpose:	Initializes the combo box of application.
;
; Entry:	hwnd = Handle to main window.
;
; Return:	No meaningful values returned.
;
; Error Handling: Quit program if the combo box could not be initialized. 
;==============================================================================

StartCombo proc hwnd:HWND
	xor EBX, EBX 
	.while EBX < LENGTHOF dwTypeTable 	; EBX -> points to compilers table.
		invoke SendMessage, 
			dword ptr [hCombo], 
			CB_ADDSTRING, 
			0, 
			dword ptr [dwTypeTable][EBX*04]
		
		.if (EAX == CB_ERR) || (EAX == CB_ERRSPACE)
			invoke MsgBoxProc, dword ptr [hwnd], addr szComboBoxError, ;*
					addr szError, addr szClose, MB_OK ;*
			invoke ExitProcess, 0 
		.endif
		
		inc EBX	
	.endw
	invoke SendMessage, dword ptr [hCombo],	CB_SETCURSEL, 0, 0
	ret
StartCombo endp

;==============================================================================
;
; Clean (hwnd)
;
; Purpose:	 Clear all program strings and restart the main dialog box fields.
;
; Called by: WndProc, Executa
;
; Entry:	hwnd  = Handle to main window.
;
; Return:	No meaningful values returned.
;==============================================================================			

Clean proc hwnd:HWND
	
	; --> Clear string buffers. <--
	
	xor EBX, EBX
	.while EBX < LENGTHOF dwCleanTable
		invoke RtlZeroMemory, dword ptr [dwCleanTable+EBX*4], MAX_PATH
		inc EBX
	.endw
	
	; --> Clear the edit boxes.	<--
	
	mov EBX, EDT_1
	.while EBX <= EDT_3
		invoke SetDlgItemText, dword ptr [hwnd], EBX, NULL
		inc EBX
	.endw
	
	; --> Reset the check buttons state. <--
	
	mov EBX, CHK_1		; EBX -> Check buttons ID.
	.while EBX <= CHK_3
		invoke GetDlgItem, dword ptr [hwnd], EBX
		mov dword ptr [hCheck], EAX
		invoke SendMessage, dword ptr [hCheck], BM_SETCHECK, BST_UNCHECKED, 0
		inc EBX
	.endw
	invoke SendMessage, dword ptr [hCombo], CB_SETCURSEL, 0, 0
	ret
Clean endp

end
;==============================================================================
;==                                 EOF                                      ==
;==============================================================================